class Player extends SpriteImage {
  Player(float x, float y, float radius, PImage image) {
    super(x, y, radius, image);
  }

  void run() {
    x=mouseX;
    // Limitation du mouvement à droite et à gauche
    if (x<image.width * scale /2) {
      x = image.width * scale /2;
    }
    if (x>width-image.width * scale /2) {
      x = width-image.width * scale /2;
    }
    super.run();
  }
}

class Tirs extends Node {
  boolean toInit=true; // Inscription à Events lors du premier passage dans run()  

  void run() {

    // l'ajout doit se faire quand l'objet est complètement construit donc pas dans le constructeur
    if (toInit) {
      events.listeningClicEvents(this);
      toInit=false;
    }
  }

  void clicEvent(float mx, float my) {
    SpriteImage laser = new SpriteImage(player.x, player.y, 10, laserImage);
    laser.vy=-10;
    lasers.add(laser);
  }
}

class Alien extends SpriteImage {
  SpriteImage player;
  Alien (float x, float y, float radius, PImage image, SpriteImage player) {
    super(x, y, radius, image);
    vy=10;
    scale=0.5;
    this.player=player;
  }
  void run() {
    if (y>height+100) {
      toRemove=true;
    }

    if (collide(player)) { 
      player.pause=true; 
      this.toRemove=true;

      /// Reset du Jeu
      jeu.pause=true;
      startgame.pause=false;
      aliens.nodes=new Node[0];
      lasers.nodes=new Node[0];
      player.pause=false;
      pauseInDraw=true;
      lasers.pause=true;
    } 


    super.run();
  }
}

class AlienBoum extends Collisions {
  AlienBoum(Nodes a, Nodes b) { 
    super(a, b) ;
  }
  void action(Area2D a1, Area2D a2) {
    a1.toRemove=true;
    a2.toRemove=true;
    score+=10;
  }
}

class boutonCollisions extends Button {

  boutonCollisions(float x, float y, float dx, float dy, String t) {
    super(x, y, dx, dy, t);
  }

  void action() {
    if (pglobal.debug) pglobal.debug=false; 
    else pglobal.debug=true;
  }
}


class StartGame extends Button {

  StartGame(float x, float y, float dx, float dy, String t) {
    super(x, y, dx, dy, t);
  }

  void action() {
    jeu.pause=false;
    this.pause=true;
    topA=millis();
    pauseInDraw=false;
    lasers.pause=false;
    score=0;
  }
}
